


import javax.swing.JFileChooser;

import javax.swing.JDesktopPane;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import javax.swing.filechooser.FileNameExtensionFilter;

import java.awt.event.*;
import java.awt.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


public class HeatPipeProgram extends JFrame
                               implements ActionListener {
    static JDesktopPane desktop;
    
    

    static JFrame frame;
    
    static prosjekt testprosjekt = new prosjekt();
   
    Cursor hourglassCursor = new Cursor(Cursor.WAIT_CURSOR);
    Cursor normalCursor = new Cursor(Cursor.DEFAULT_CURSOR);
    
    public HeatPipeProgram() {
        super("Heat Pipe");
       frame = this;
       
      try {
		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
       } catch (Exception e) {
		System.out.println(e);
       }
	
        //Make the big window be indented 50 pixels from each edge
        //of the screen.
        int inset = 50;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds(inset, inset,
                  screenSize.width  - inset*2,
                  screenSize.height - inset*2);

        //Set up the GUI.
        desktop = new JDesktopPane(); //a specialized layered pane
        
        
        //createFrame(); //create first "window" TULL..LAGER EIT VINDU AV INTERNALFRAMEDEMO...trenger ikkje
        
       
        setContentPane(desktop);
        setJMenuBar(createMenuBar());

        //Make dragging a little faster but perhaps uglier.
        //desktop.setDragMode(JDesktopPane.OUTLINE_DRAG_MODE);
    }

    protected JMenuBar createMenuBar() {
        JMenuBar menuBar = new JMenuBar();

        //Set up the lone menu.
        JMenu documentmenu = new JMenu("Fil");
        documentmenu.setMnemonic(KeyEvent.VK_F);
        menuBar.add(documentmenu);

        //Set up the first menu item.
        JMenuItem menuItem = new JMenuItem("New");
        menuItem.setMnemonic(KeyEvent.VK_N);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_N, ActionEvent.ALT_MASK));
        menuItem.setActionCommand("new");
        menuItem.addActionListener(this);
        documentmenu.add(menuItem);
        
        JMenuItem menuItem_lagre = new JMenuItem("Lagre");
        menuItem_lagre.setActionCommand("Lagre");
        menuItem_lagre.addActionListener(this);
        documentmenu.add(menuItem_lagre);

        JMenuItem menuItem_open = new JMenuItem("pne");
        menuItem_open.setActionCommand("pne");
        menuItem_open.addActionListener(this);
        documentmenu.add(menuItem_open);

        
        //Set up the second menu item.
        menuItem = new JMenuItem("Quit");
        menuItem.setMnemonic(KeyEvent.VK_Q);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_Q, ActionEvent.ALT_MASK));
        menuItem.setActionCommand("quit");
        menuItem.addActionListener(this);
        documentmenu.add(menuItem);
        
      
        
        //Set up the lone menu.
        JMenu redigerMenu = new JMenu("Rediger");
        redigerMenu.setMnemonic(KeyEvent.VK_R);
        menuBar.add(redigerMenu);

        //Set up the first menu item.
        JMenuItem menuItem_egenskaper = new JMenuItem("Egenskaper");
        menuItem_egenskaper.setMnemonic(KeyEvent.VK_E);
        menuItem_egenskaper.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_E, ActionEvent.ALT_MASK));
        menuItem_egenskaper.setActionCommand("egenskaper");
        menuItem_egenskaper.addActionListener(this);
        redigerMenu.add(menuItem_egenskaper);
        
        
        
        //Set up the lone menu.
        JMenu simulerMenu = new JMenu("Beregn");
        simulerMenu.setMnemonic(KeyEvent.VK_B);
        menuBar.add(simulerMenu);

        //Set up the first menu item.
        JMenuItem menuItem_dampkurve = new JMenuItem("Damptrykkskurve");
        menuItem_dampkurve.setMnemonic(KeyEvent.VK_D);
        menuItem_dampkurve.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_D, ActionEvent.ALT_MASK));
        menuItem_dampkurve.setActionCommand("Damptrykkskurve");
        menuItem_dampkurve.addActionListener(this);
        simulerMenu.add(menuItem_dampkurve);
        
        JMenuItem menuItem_veskekurve = new JMenuItem("Vsketrykkskurve");
        menuItem_veskekurve.setMnemonic(KeyEvent.VK_V);
        menuItem_veskekurve.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_V, ActionEvent.ALT_MASK));
        menuItem_veskekurve.setActionCommand("Vsketrykkskurve");
        menuItem_veskekurve.addActionListener(this);
        simulerMenu.add(menuItem_veskekurve);
        
        
        JMenuItem menuItem_kombinertKurve = new JMenuItem("Lag kombinert vske/damp kurve");
        menuItem_kombinertKurve .setActionCommand("Lag kombinert vske/damp kurve");
        menuItem_kombinertKurve .addActionListener(this);
        simulerMenu.add(menuItem_kombinertKurve );
        
               
        JMenuItem menuItem_kaplimit = new JMenuItem("Beregn kappilrgrense (punkt)");
        menuItem_kaplimit.setActionCommand("Beregn kappilrgrense (punkt)");
        menuItem_kaplimit.addActionListener(this);
        simulerMenu.add(menuItem_kaplimit);
        
        
        JMenuItem menuItem_fordamperDeltaH = new JMenuItem("Beregn h i fordamper");
        menuItem_fordamperDeltaH.setActionCommand("Beregn grensesnittmotstand h i fordamper");
        menuItem_fordamperDeltaH.addActionListener(this);
        simulerMenu.add(menuItem_fordamperDeltaH);
        
        JMenuItem menuItem_kondensatorDeltaH = new JMenuItem("Beregn h i kondensator");
        menuItem_kondensatorDeltaH.setActionCommand("Beregn grensesnittmotstand h i kondensator");
        menuItem_kondensatorDeltaH.addActionListener(this);
        simulerMenu.add(menuItem_kondensatorDeltaH);
        
        JMenuItem menuItem_begrensningskurve = new JMenuItem("Finn begrensninger");
        menuItem_begrensningskurve.setMnemonic(KeyEvent.VK_B);
        menuItem_begrensningskurve.setAccelerator(KeyStroke.getKeyStroke(
                KeyEvent.VK_B, ActionEvent.ALT_MASK));
        menuItem_begrensningskurve.setActionCommand("Finn begrensninger");
        menuItem_begrensningskurve.addActionListener(this);
        simulerMenu.add(menuItem_begrensningskurve);
        
        JMenuItem menuItem_ytterveggTemp = new JMenuItem("Ytelse");
       
        menuItem_ytterveggTemp.setActionCommand("Ytelse");
        menuItem_ytterveggTemp.addActionListener(this);
        simulerMenu.add(menuItem_ytterveggTemp);
        
        JMenuItem menuItem_diameter = new JMenuItem("Minimum radius");
        menuItem_diameter.setActionCommand("Minimum radius");
        menuItem_diameter.addActionListener(this);
        simulerMenu.add(menuItem_diameter);
        
        JMenuItem menuItem_re = new JMenuItem("Radielt Reynoldsnummer");
        menuItem_re.setActionCommand("Radielt Reynoldsnummer");
        menuItem_re.addActionListener(this);
        simulerMenu.add(menuItem_re);

       

        return menuBar;
    }

    //React to menu selections.
    public void actionPerformed(ActionEvent e) {
        if ("Damptrykkskurve".equals(e.getActionCommand())) 
        	{ //new
        	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
        	
        	
        	
        	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
	        	chartFrame graf = testprosjekt.getDampkurve(testprosjekt.lagDampkurve(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()),((testprosjekt.varmeror.geometri.lengdeFordamper + testprosjekt.varmeror.geometri.lengdeAdiabatisk + testprosjekt.varmeror.geometri.lengdeKondensator)/dialog.getSteps()),dialog.getTemp(),dialog.getFluks());
	        	desktop.add(graf);
	        	try {
	        		graf.setSelected(true);
	            	} catch (java.beans.PropertyVetoException e1) {}
	        	}
        	} 
        
        else if("Vsketrykkskurve".equals(e.getActionCommand())) 
        	{
        	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
        	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
	        	chartFrame graf = testprosjekt.getVeskekurve(testprosjekt.lagVeskekurve(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()),((testprosjekt.varmeror.geometri.lengdeFordamper + testprosjekt.varmeror.geometri.lengdeAdiabatisk + testprosjekt.varmeror.geometri.lengdeKondensator)/dialog.getSteps()),dialog.getTemp(),dialog.getFluks());
	        	desktop.add(graf);
	        	try {
	        		graf.setSelected(true);
	            	} catch (java.beans.PropertyVetoException e1) {}
	        	}
        	}
        
        else if("Lag kombinert vske/damp kurve".equals(e.getActionCommand())) 
	    	{
	    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
	    	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
	        	chartFrame graf = testprosjekt.getVeskekurve(testprosjekt.lagVeskekurve(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()),((testprosjekt.varmeror.geometri.lengdeFordamper + testprosjekt.varmeror.geometri.lengdeAdiabatisk + testprosjekt.varmeror.geometri.lengdeKondensator)/dialog.getSteps()),dialog.getTemp(),dialog.getFluks());
	        	graf.leggTilSerie(testprosjekt.lagDampkurve(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()),"Damptrykk",((testprosjekt.varmeror.geometri.lengdeFordamper + testprosjekt.varmeror.geometri.lengdeAdiabatisk + testprosjekt.varmeror.geometri.lengdeKondensator)/dialog.getSteps()));
	        	
	        	desktop.add(graf);
	        	try {
	        		graf.setSelected(true);
	            	} catch (java.beans.PropertyVetoException e1) {}
	        	}
	    	}
        
        
        else if("Radielt Reynoldsnummer".equals(e.getActionCommand())) 
    	{
    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
    	if (dialog.closeMethod == punktBeregningDialog.OK)
        	{
        	chartFrame graf = testprosjekt.getRekurve(testprosjekt.ReLagkurve(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()),((testprosjekt.varmeror.geometri.lengdeFordamper + testprosjekt.varmeror.geometri.lengdeAdiabatisk + testprosjekt.varmeror.geometri.lengdeKondensator)/dialog.getSteps()),dialog.getTemp(),dialog.getFluks());
        	
        	desktop.add(graf);
        	try {
        		graf.setSelected(true);
            	} catch (java.beans.PropertyVetoException e1) {}
        	}
    	}
        
        
        else if("Beregn h kondensasjon (punkt)".equals(e.getActionCommand())) 
	    	{
	    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
	    	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
	        	
	        	
	        	
	        	}
	    	}
        
        else if("Beregn grensesnittmotstand h i fordamper".equals(e.getActionCommand())) 
    	{
    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
    	if (dialog.closeMethod == punktBeregningDialog.OK)
        	{
        	
        	
        	textOutputWindow kondensasjonsfilmInfoWindow = new textOutputWindow(	"Beregning av termisk grensesnittmotstand i formdaper for Qe " + Double.toString(dialog.getFluks()) + "kW, Te:" +Double.toString(dialog.getTemp())+"K",
        																			testprosjekt.gethDelta_fordamper(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()  ));
        	desktop.add(kondensasjonsfilmInfoWindow);
        	}
    	}
        
        
        else if("Beregn grensesnittmotstand h i kondensator".equals(e.getActionCommand())) 
    	{
    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
    	if (dialog.closeMethod == punktBeregningDialog.OK)
        	{
        	
        	
        	textOutputWindow kondensasjonsfilmInfoWindow = new textOutputWindow(	"Beregning av termisk grensesnittmotstand i kondensator for Qe " + Double.toString(dialog.getFluks()) + "kW, Te:" +Double.toString(dialog.getTemp())+"K",
        																			testprosjekt.gethDelta_kondensator(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()  ));
        	desktop.add(kondensasjonsfilmInfoWindow);
        	try {
        		kondensasjonsfilmInfoWindow.setSelected(true);
            	} catch (java.beans.PropertyVetoException e1) {}
        	}
    	}
        
        
        
        else if("Beregn kappilrgrense (punkt)".equals(e.getActionCommand())) 
    	{
    	punktBeregningDialog dialog = new punktBeregningDialog(frame,null);
    	
    	if (dialog.closeMethod == punktBeregningDialog.OK)
        	{
        	        	
        	textOutputWindow kondensasjonsfilmInfoWindow = new textOutputWindow(	"Beregning av kappilrgrense for Qe " + Double.toString(dialog.getFluks()) + "kW, Te:" +Double.toString(dialog.getTemp())+"K",
        																			testprosjekt.getCapLimit(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()));
        	desktop.add(kondensasjonsfilmInfoWindow);
        	try {
        		kondensasjonsfilmInfoWindow.setSelected(true);
            	} catch (java.beans.PropertyVetoException e1) {}
        	}
    	
    	
    	}
        
        
        else if("Minimum radius".equals(e.getActionCommand())) 
    	{
        	
        	punktBeregningDialog dialog = new punktBeregningDialog(frame,"Temperatur p damp");;
	    	
	    	 
	    	
	    	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
    	
	    		setCursor(hourglassCursor);   	
        	textOutputWindow kondensasjonsfilmInfoWindow = new textOutputWindow(	"Beregning av minimum diameter",
        																			testprosjekt.minimumDiameter(dialog.getFluks(), dialog.getSteps(), dialog.getTemp() ));
        	desktop.add(kondensasjonsfilmInfoWindow);
        	try {
        		kondensasjonsfilmInfoWindow.setSelected(true);
            	} catch (java.beans.PropertyVetoException e1) {}
	        	}
	    	setCursor(normalCursor);
    	}
        
        else if("Ytelse".equals(e.getActionCommand())) 
	    	{
	    	punktBeregningDialog dialog = new punktBeregningDialog(frame,"Veggtemperatur p ytterside av fordamper [K]");;
	    	
	    	
	    	
	    	if (dialog.closeMethod == punktBeregningDialog.OK)
	        	{
	    		setCursor(hourglassCursor);         	
	        	textOutputWindow kondensasjonsfilmInfoWindow = new textOutputWindow(	"Ytterveggtemperaturer for Qe " + Double.toString(dialog.getFluks()) + "kW, Te:" +Double.toString(dialog.getTemp())+"K",
	        																			testprosjekt.getOutsideTempeKondensator(dialog.getFluks(), dialog.getSteps(), dialog.getTemp()));
	        	desktop.add(kondensasjonsfilmInfoWindow);
	        	try {
	        		kondensasjonsfilmInfoWindow.setSelected(true);
	            	} catch (java.beans.PropertyVetoException e1) {}
	        	}
	    	setCursor(normalCursor);
	    	}
        
        else if("Finn begrensninger".equals(e.getActionCommand())) 
    		{
        	begrensningsDialog begrensningsDialog = new begrensningsDialog(frame,testprosjekt.Qmin,testprosjekt.Qmax,testprosjekt.Tmin,testprosjekt.Tmax);
        	if (begrensningsDialog.closeMethod == begrensningsDialog.OK)
	        	{
        		setCursor(hourglassCursor);   
        		limitChartFrame graf = 
	        	testprosjekt.getBegrensninger(	begrensningsDialog.getQmin(), 
	    										begrensningsDialog.getQmax(), 
	    										begrensningsDialog.getTmin(), 
	    										begrensningsDialog.getTmax(), 
	    										
	    										begrensningsDialog.getQStepSize(),
	    										begrensningsDialog.getEulerSteps());
	    		desktop.add(graf);
	        	try {
	        		graf.setSelected(true);
	            	} catch (java.beans.PropertyVetoException e1) {}
	            }
        	setCursor(normalCursor);
    		}
        else if ("egenskaper".equals(e.getActionCommand())) 
        	{ 
        	createPropertiesFrame();
        	}
        
        else if ("pne".equals(e.getActionCommand())) 
    		{
        	JFileChooser fildialog = new JFileChooser();
        	fildialog.setFileFilter(new FileNameExtensionFilter("Heat Pipe file (.hpf)", "hpf")); 
        	int returnVal = fildialog.showOpenDialog(this);
        	 
        	 
             if (returnVal == JFileChooser.APPROVE_OPTION) 
             	{
                File file = fildialog.getSelectedFile();
                FileInputStream fis = null;
            	ObjectInputStream in = null;
            	try
            		{
            		fis = new FileInputStream(file);
            		in = new ObjectInputStream(fis);
            		testprosjekt.varmeror = (varmeror)in.readObject();
            		in.close();
            		JOptionPane.showMessageDialog(null, "Fil pnet.");
            		}
            	catch(IOException ex)
            		{
            		JOptionPane.showMessageDialog(null, "Feil ved pning av fil!.",
            			    "Feil",
            			    JOptionPane.ERROR_MESSAGE);
            		ex.printStackTrace();
            		
            		}
            		catch(ClassNotFoundException ex)
            			{
            			JOptionPane.showMessageDialog(null, "Feil ved pning av fil!.",
                			    "Feil",
                			    JOptionPane.ERROR_MESSAGE);
            			ex.printStackTrace();
            			}
            		
             		} 
    		}
        
        else if ("Lagre".equals(e.getActionCommand())) 
			{
        
        	JFileChooser fildialog = new JFileChooser();
        	fildialog.setFileFilter(new FileNameExtensionFilter("Heat Pipe file (.hpf)", "hpf")); 
        	int returnVal = fildialog.showSaveDialog(this);

        	if (returnVal == JFileChooser.APPROVE_OPTION) {
        	    File file = fildialog.getSelectedFile();
        	    FileOutputStream fos = null;
        	         ObjectOutputStream out = null;
        	         try
        	         {
        	           fos = new FileOutputStream(file);
        	           out = new ObjectOutputStream(fos);
        	           out.writeObject(testprosjekt.varmeror);
        	           out.close();
        	         }
        	         catch(IOException ex)
        	         {
        	           ex.printStackTrace();
        	         }
        		}
			}
        
        else if ("New".equals(e.getActionCommand())) 
		{
    
    	HeatPipeProgram nyttprogram = new HeatPipeProgram();
		}
        
        else { //quit
            quit();
        }
    }

    //Create a new internal frame.
    protected void createFrame() {
       
    }
    
    protected static void createPropertiesFrame() {
        propertiesFrame egenskaperFrame = new propertiesFrame(frame,testprosjekt.varmeror);
        //egenskaperFrame.setVisible(true); //necessary as of 1.3
        //desktop.add(egenskaperFrame);
        if (egenskaperFrame.closeMethod == propertiesFrame.OK)
        	{	
        	testprosjekt.varmeror = egenskaperFrame.getProperties();
        	}
        /*try {
        	egenskaperFrame.setSelected(true);
        } catch (java.beans.PropertyVetoException e) {}*/
    }

    //Quit the application.
    protected void quit() {
        System.exit(0);
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        //JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
    	HeatPipeProgram frame = new HeatPipeProgram();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        
        //Display the window.
        frame.setVisible(true);
        testprosjekt.initDummyVariables();  //SLETT DENNE
        }


    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() 
            {
            createAndShowGUI();
             
            }
            
        });
        
    }

  
}