
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;



import javax.swing.JDialog;

import javax.swing.JLabel;

import javax.swing.JPanel;

import javax.swing.JTextField;




public class begrensningsDialog extends JDialog {
	
/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	geometriFane geometriFane;
	vekeFane vekeFane;
	arbeidsmediumFane arbeidsmediumFane;
	static final Integer AVBRYT = 0;
	static final Integer OK = 1;
	Integer closeMethod;
	
	JTextField textQmin;
	JTextField textQmax;
	JTextField textTmin;
	JTextField textTmax;
	
	JTextField qStepSize;
	JTextField eulerNrSteps;

	
	public begrensningsDialog(Frame frame,double qmin,double qmax,double tmin,double tmax) {
		super(frame, true);
		setDefaultLookAndFeelDecorated(true);
		
		setModal(true);
		setTitle("Velg omrde for beregning av varmetransportbegrensninger");
		setResizable(false);
      	
		
  
		setLayout(new BorderLayout());
		
         
        
        JPanel tekstbokser = new JPanel(new GridLayout(12,1,2,2));;
       
        JLabel qeminLabel = new JLabel("Minimum varmebelastning (Qe) i fordamper [kW?]");
    	tekstbokser.add(qeminLabel);
    	textQmin = new JTextField(Double.toString(qmin));
    	tekstbokser.add(textQmin);
        
    	JLabel qemaxLabel = new JLabel("Maksimum varmebelastning (Qe) i fordamper [kW?]");
    	tekstbokser.add(qemaxLabel);
    	textQmax = new JTextField(Double.toString(qmax));
    	tekstbokser.add(textQmax);
    	
    	JLabel teminLabel = new JLabel("Minimum damptemperatur i fordamper [K]");
    	tekstbokser.add(teminLabel);
    	textTmin = new JTextField(Double.toString(tmin));
    	tekstbokser.add(textTmin);
        
    	JLabel temaxLabel = new JLabel("Maksimum damptemperatur i fordamper [K]");
    	tekstbokser.add(temaxLabel);
    	textTmax = new JTextField(Double.toString(tmax));
    	tekstbokser.add(textTmax);
        
    	JLabel qStepSizeLabel = new JLabel("Stegstrrelse for Qe i lkke fra Qmin til Qmax [kW]"); //For hver temperatur kes fluksen fra qmin til qmaks mens programmet sker etter begrensninger. Denne variablen anngir kningen i fluks for hver gang lkka kjrer.
    	tekstbokser.add(qStepSizeLabel);
    	qStepSize = new JTextField("0.01");
    	tekstbokser.add(qStepSize);
    	
    	JLabel eulerNrStepsLabel = new JLabel("Antall steg i forlengs Euler");
    	tekstbokser.add(eulerNrStepsLabel);
    	eulerNrSteps = new JTextField("200");
    	tekstbokser.add(eulerNrSteps);
       
        getContentPane().add(tekstbokser, BorderLayout.CENTER);
       
    //Lager knapperad med pne og lukke knapp
		JPanel knapperad = new JPanel(new GridLayout(1,2,230,20));
		
		Button avbrytKnapp = new Button("Avbryt");
		Button okKnapp = new Button("Ok");
		    
		knapperad.add(avbrytKnapp);
		knapperad.add(okKnapp);
	
		getContentPane().add(knapperad, BorderLayout.SOUTH);
		
		 

	
	//Hndterer events (kanpper blir trykt p)
	avbrytKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
		  closeMethod = AVBRYT; 
		  dispose();
		  } 
		});
	
	okKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
			
			  closeMethod = OK;
		   dispose();
		  } 
		});
        
	setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		

        //Set the window's location.
        //setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
	
	//setProperties(current_varmeror);
	pack();
	
	Toolkit toolkit = Toolkit.getDefaultToolkit();  
    Dimension screenSize = toolkit.getScreenSize();
	
	int x = (screenSize.width - getWidth()) / 2;  
	int y = (screenSize.height - getHeight()) / 2;  
	  
	//Set the new frame location  
	setLocation(x, y); 
	
	this.setVisible(true);
	}
	


public double getQmin()
 	{
	return  Double.parseDouble(textQmin.getText());	
	}

public double getQmax()
	{
	return  Double.parseDouble(textQmax.getText());	
	}

public double getTmin()
	{
	return  Double.parseDouble(textTmin.getText());	
	}

public double getTmax()
	{
	return  Double.parseDouble(textTmax.getText());	
	}
public double getQStepSize()
	{
	return  Double.parseDouble(qStepSize.getText());	
	}
public int getEulerSteps()
	{
	return  Integer.parseInt(eulerNrSteps.getText());	
	}


}//EoC

