import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;



import javax.swing.JDialog;


import javax.swing.JPanel;

import javax.swing.JTabbedPane;





public class propertiesFrame extends JDialog {
	
/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	geometriFane geometriFane;
	vekeFane vekeFane;
	arbeidsmediumFane arbeidsmediumFane;
	static final Integer AVBRYT = 0;
	static final Integer OK = 1;
	Integer closeMethod;

	
	public propertiesFrame(Frame frame,varmeror current_varmeror) {
		super(frame, true);
		setDefaultLookAndFeelDecorated(true);
		
		setModal(true);
		setTitle("Egenskaper for varmerr");
		setResizable(false);
      	
        /*lager Tabell med egenskaper for varmerr. I denne tabellen skal alle verdier puttes inn.
        ...se http://java.sun.com/docs/books/tutorial/uiswing/components/table.html for meir
        
        *Greske Unicode (for  skrive greske symboler i java) kan finnes p 
        *http://www.ssec.wisc.edu/~tomw/java/unicode.html#x0370
        *
        */
		setLayout(new BorderLayout());
		
         
        
        JTabbedPane tabbedPane = new JTabbedPane();
        geometriFane = new geometriFane();
        tabbedPane.addTab("Varmerrbeholder", null, geometriFane,
                          "Egenskaper for varmerrbeholder");
       
        vekeFane = new vekeFane();
        tabbedPane.addTab("Veke", null, vekeFane,
                          "Egenskaper for veke");
        arbeidsmediumFane = new arbeidsmediumFane();
        tabbedPane.addTab("Arbeidsmedium", null, arbeidsmediumFane,
                          "Egenskaper for arbeidsmedium");
        
        
        
        
        /*arbeidsmedium kalium = new arbeidsmedium();
        File testFile = new File("C:\\temp\\kalium.txt");
        
        JTable table = new JTable(kalium.lesFraFil(testFile),kalium.arbeidsmediumKolonneOverskrifter);
        JScrollPane scrollPane = new JScrollPane(table);
        table.setFillsViewportHeight(true);
        
        
        setSize(300,300);
        getContentPane().add(scrollPane, BorderLayout.CENTER);*/
        setSize(600,370);
        getContentPane().add(tabbedPane, BorderLayout.CENTER);
       
    //Lager knapperad med pne og lukke knapp
		JPanel knapperad = new JPanel(new GridLayout(1,2,230,20));
		
		Button avbrytKnapp = new Button("Avbryt");
		Button okKnapp = new Button("Ok");
		    
		knapperad.add(avbrytKnapp);
		knapperad.add(okKnapp);
	
		getContentPane().add(knapperad, BorderLayout.SOUTH);
		
		 

	
	//Hndterer events (kanpper blir trykt p)
	avbrytKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
		  closeMethod = AVBRYT; 
		  dispose();
		  } 
		});
	
	okKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
		   closeMethod = OK;
		   dispose();
		  } 
		});
        
	setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		

        //Set the window's location.
        //setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
	
	setProperties(current_varmeror);
	
	Toolkit toolkit = Toolkit.getDefaultToolkit();  
    Dimension screenSize = toolkit.getScreenSize();
	
	int x = (screenSize.width - getWidth()) / 2;  
	int y = (screenSize.height - getHeight()) / 2;  
	  
	//Set the new frame location  
	setLocation(x, y); 
	
	this.setVisible(true);
	}
	

public void setProperties(varmeror current_varmeror)
	//Setter verdier i alle tekstbokser fra di verdiene som er i bruk (prosjekt)
	{
	String verdi = "";
	
	try {
		verdi = Double.toString(current_varmeror.geometri.indreRadius);
		if(verdi != "NaN") {geometriFane.textIndreRadius.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.geometri.ytreRadius);
		if(verdi != "NaN") {geometriFane.textYtreRadius.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.geometri.lengdeFordamper);
		if(verdi != "NaN") {geometriFane.textLengdeFordamper.setText(verdi);}

		verdi = Double.toString(current_varmeror.geometri.lengdeAdiabatisk);
		if(verdi != "NaN") {geometriFane.textLengdeAdiabatisk.setText(verdi);}

		verdi = Double.toString(current_varmeror.geometri.lengdeKondensator);
		if(verdi != "NaN") {geometriFane.textLengdeKondensator.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.geometri.tilt);
		if(verdi != "NaN") {geometriFane.textTiltHP.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.geometri.beholderTykkelse);
		if(verdi != "NaN") {geometriFane.textBeholdertykkelse.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.geometri.beholderKonduktivitet);
		if(verdi != "NaN") {geometriFane.textBeholderKonduktivitet.setText(verdi);}

	
		
		
		
		
		verdi = Double.toString(current_varmeror.veke.permeabilitet);
		if(verdi != "NaN") {vekeFane.textPermabilitet.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.veke.effektivPoreradius);
		if(verdi != "NaN") {vekeFane.textPoreradius.setText(verdi);}
		
		verdi = Integer.toString(current_varmeror.veke.vekeType);
		if(verdi != "NaN") {vekeFane.textVeketype.setSelectedIndex(current_varmeror.veke.vekeType);}
		
		verdi = current_varmeror.veke.vekeNavn;
		if(verdi != "") {vekeFane.textVekenavn.setText(verdi);}
		
		verdi = current_varmeror.veke.vekeBeskrivelse;
		if(verdi != "") {vekeFane.textVekebeskrivelse.setText(verdi);}
		
		
		
		verdi = Double.toString(current_varmeror.veke.konduktivitet);
		if(verdi != "NaN") {vekeFane.textKonduktivitet.setText(verdi);}
		
		verdi = Double.toString(current_varmeror.veke.porositet);
		if(verdi != "NaN") {vekeFane.textPorositet.setText(verdi);}
				
		
		
		verdi = Double.toString(current_varmeror.arbeidsmedium.molarMasse);
		if(verdi != "NaN") {arbeidsmediumFane.textMolarMasse.setText(verdi);}
		
		verdi = current_varmeror.arbeidsmedium.arbeidsmediumNavn;
		if(verdi != "") {arbeidsmediumFane.textNavn.setText(verdi);}
		
		
		
		arbeidsmediumFane.valgtarbeidsmedium = current_varmeror.arbeidsmedium;
		for(int y=0;y<arbeidsmediumFane.valgtarbeidsmedium.arbeidsmediumData.length;y++)
      		{
	     	for(int x=0;x<12;x++)
		        	{
	     		arbeidsmediumFane.table.setValueAt(arbeidsmediumFane.valgtarbeidsmedium.arbeidsmediumData[y][x],y,x); 	
		        	}}
		} catch (NullPointerException e) {};
	
		
	}
	
public varmeror getProperties()
 	{
		
	 varmeror properties_from_dialog = new varmeror();
	

	 try {	properties_from_dialog.geometri.indreRadius = Double.parseDouble(geometriFane.textIndreRadius.getText());
	
	 properties_from_dialog.geometri.ytreRadius = Double.parseDouble(geometriFane.textYtreRadius.getText());
	 properties_from_dialog.geometri.lengdeFordamper = Double.parseDouble(geometriFane.textLengdeFordamper.getText());
	 properties_from_dialog.geometri.lengdeAdiabatisk = Double.parseDouble(geometriFane.textLengdeAdiabatisk.getText());
	 properties_from_dialog.geometri.lengdeKondensator = Double.parseDouble(geometriFane.textLengdeKondensator.getText());
	 properties_from_dialog.geometri.tilt = Double.parseDouble(geometriFane.textTiltHP.getText());
	 properties_from_dialog.geometri.beholderTykkelse = Double.parseDouble(geometriFane.textBeholdertykkelse.getText());
	 properties_from_dialog.geometri.beholderKonduktivitet = Double.parseDouble(geometriFane.textBeholderKonduktivitet.getText());
	
	} catch (NumberFormatException e) {System.out.println("Feil ved konvertering fra String til Double (geometri)"); }

	try {	properties_from_dialog.veke.permeabilitet = Double.parseDouble(vekeFane.textPermabilitet.getText());
	 properties_from_dialog.veke.effektivPoreradius = Double.parseDouble(vekeFane.textPoreradius.getText());
	 properties_from_dialog.veke.vekeType = vekeFane.textVeketype.getSelectedIndex();
	 properties_from_dialog.veke.vekeNavn = vekeFane.textVekenavn.getText();
	 properties_from_dialog.veke.vekeBeskrivelse = vekeFane.textVekebeskrivelse.getText();
	 
	 properties_from_dialog.veke.konduktivitet = Double.parseDouble(vekeFane.textKonduktivitet.getText());
	 properties_from_dialog.veke.porositet = Double.parseDouble(vekeFane.textPorositet.getText());
		 
	} catch (NumberFormatException e) {System.out.println("Feil ved konvertering fra String til Double (veke)" + e); } 

	
	

	properties_from_dialog.arbeidsmedium = arbeidsmediumFane.valgtarbeidsmedium;
	try {
	
	properties_from_dialog.arbeidsmedium.molarMasse = Double.parseDouble(arbeidsmediumFane.textMolarMasse.getText());
	properties_from_dialog.arbeidsmedium.arbeidsmediumNavn = arbeidsmediumFane.textNavn.getText();
	} catch (NumberFormatException e) {System.out.println("Feil ved konvertering fra String til Double (veke)" + e); } 
	return  properties_from_dialog;
 	}

}
