import java.io.Serializable;

public class veke implements Serializable {

	public double permeabilitet; // Permeabilitet K for arbeidsmediumet
	public double effektivPoreradius; // Effektiv poreradius reff
	public int vekeType; // Type refererer til de ulike typene nedenfor.
	public String vekeNavn; // Navn p veke
	public String vekeBeskrivelse; // kort beskrivelse av vekestruktur

	public double konduktivitet; // Konduktivitet for vekemateriale ks

	public double porositet;

	// uLIKE TYPER VEKESTRUKTURER
	static final int CIRCULAR_ARTERY = 0;
	static final int ANNULAR_CHANNEL = 1;
	static final int RECTANGULAR_CHANNEL = 2;
	static final int RECTANGULAR_GROOVES = 3;
	static final int TRIANGULAR_GROOVES = 4;
	static final int TRAPEZODIAL_GROOVES = 5;
	static final int CIRCULAR_GROOVES = 6;
	static final int METALLNETT = 7; // PLAIN OR SINTERED
	static final int SINTREDE_VEKER_AV_METALLPULVER = 8; // PLAIN OR SINTERED
	static final int SINTERED_FELTED_METAL_FIBERS = 9;
	static final int SCREEN_COVERED_RECTANGULAR_GROOVE = 10;
	static final int SCREEN_COVERED_TRIANGULAR_GROOVE = 11;
	static final int FOAM = 12;

	static final String[] vekeTypeNavn = { "IKKE TILGJENGELIG Circual artery",
			"IKKE TILGJENGELIG Annular channel",
			"IKKE TILGJENGELIG Rectangular channel",
			"IKKE TILGJENGELIG Rectangular grooves",
			"IKKE TILGJENGELIG Triangular grooves",
			"IKKE TILGJENGELIG Trapezodial grooves",
			"IKKE TILGJENGELIG Circular grooves", "Metallnetting (flere lag)",
			"Sintrede veker av metallpulver",
			"IKKE TILGJENGELIG Sintered feltet metal fibers",
			"IKKE TILGJENGELIG Screen covered Rectangular groove",
			"IKKE TILGJENGELIG Screen covered triangular groove",
			"IKKE TILGJENGELIG Foam" };

}
