import java.awt.BorderLayout;

import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.JComboBox;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;

public class vekeFane extends JPanel {
	JLabel labelVekeNavn;
	JTable table;
	JScrollPane scrollPane;
	veke valgtveke;
	JTextField textPermabilitet;
	JTextField textPoreradius;
	JComboBox textVeketype;
	JTextField textVekenavn;
	JTextField textVekebeskrivelse;

	JTextField textKonduktivitet;

	JTextField textPorositet;

	public vekeFane() {
		setLayout(new BorderLayout(5, 5));
		valgtveke = new veke(); // Lager tomt veke. M implementere slik at den
								// velger

		// Navn p arbeidsmedium (filnavn)
		labelVekeNavn = new JLabel("Egenskaper for veke");
		add(labelVekeNavn, BorderLayout.NORTH);

		// Lager teksfields for ulike egenskaper for veke
		JPanel tekstbokser = new JPanel(new GridLayout(9, 2, 80, 2));

		JLabel labelPermabilitet = new JLabel("Permabilitet K");
		tekstbokser.add(labelPermabilitet);
		textPermabilitet = new JTextField(30);
		tekstbokser.add(textPermabilitet);

		JLabel labelPoreradius = new JLabel("Effektiv poreradius reff");
		tekstbokser.add(labelPoreradius);
		textPoreradius = new JTextField(5);
		tekstbokser.add(textPoreradius);

		JLabel labelVeketype = new JLabel("Veketype");
		tekstbokser.add(labelVeketype);
		textVeketype = new JComboBox(veke.vekeTypeNavn);
		tekstbokser.add(textVeketype);

		JLabel labelNavn = new JLabel("Vekenavn");
		tekstbokser.add(labelNavn);
		textVekenavn = new JTextField(30);
		tekstbokser.add(textVekenavn);

		JLabel labelVekebeskrivelse = new JLabel("Beskrivelse");
		tekstbokser.add(labelVekebeskrivelse);
		textVekebeskrivelse = new JTextField(30);
		tekstbokser.add(textVekebeskrivelse);

		

		JLabel labelKonduktivitet = new JLabel("Konduktivitet k");
		tekstbokser.add(labelKonduktivitet);
		textKonduktivitet = new JTextField(5);
		tekstbokser.add(textKonduktivitet);

		JLabel labelPorositett = new JLabel("Porsitet \u03C6 ");
		tekstbokser.add(labelPorositett);
		textPorositet = new JTextField(5);
		tekstbokser.add(textPorositet);
		
		JLabel tomLabel = new JLabel(" ");
		tekstbokser.add(tomLabel);
		JLabel tomLabel2 = new JLabel(" ");
		tekstbokser.add(tomLabel2);
		
		add(tekstbokser, BorderLayout.CENTER);
	}

	public void oppdaterTekstbokser() {
		textPermabilitet.setText(Double.toString(valgtveke.permeabilitet));
		textPoreradius.setText(Double.toString(valgtveke.effektivPoreradius));
		textVeketype.setSelectedIndex(valgtveke.vekeType);
		textVekenavn.setText(valgtveke.vekeNavn);
		textVekebeskrivelse.setText(valgtveke.vekeBeskrivelse);
		
		textKonduktivitet.setText(Double.toString(valgtveke.konduktivitet));
		textPorositet.setText(Double.toString(valgtveke.porositet));
	}

	public Insets getInsets() {
		// Creates and initializes a new Insets object with the specified
		// top, left, bottom, and right insets.
		return new Insets(10, 10, 10, 10);
	}
}
