

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;



import javax.swing.JDialog;
import javax.swing.JOptionPane;

import javax.swing.JLabel;

import javax.swing.JPanel;

import javax.swing.JTextField;




public class punktBeregningDialog extends JDialog {
	
/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	geometriFane geometriFane;
	vekeFane vekeFane;
	arbeidsmediumFane arbeidsmediumFane;
	static final Integer AVBRYT = 0;
	static final Integer OK = 1;
	Integer closeMethod;
	
	JTextField QeTextBox;
	JTextField tempFordamperText;
	JTextField stepsText;
	JLabel tempFordamper;

	
	public punktBeregningDialog(Frame frame, String tempLabelNavn) {
		super(frame, true);
		setDefaultLookAndFeelDecorated(true);
		
		setModal(true);
		setTitle("Velg parametere");
		setResizable(false);
      	
		 
  
		setLayout(new BorderLayout());
		
         
        
        JPanel tekstbokser = new JPanel(new GridLayout(6,1,2,2));;
       
        JLabel QeLabel = new JLabel("Varmebelastning i fordamper Qe [kW]");
    	tekstbokser.add(QeLabel);
    	QeTextBox = new JTextField("0.0");
    	tekstbokser.add(QeTextBox);
        
    	tempFordamper = new JLabel("Metningstemperatur i fordamper Te [K]");
    	tekstbokser.add(tempFordamper);
    	tempFordamperText = new JTextField("0.0");
    	tekstbokser.add(tempFordamperText);
    	
    	JLabel stepLabel = new JLabel("Antall steg i forlengs euler");
    	tekstbokser.add(stepLabel);
    	stepsText = new JTextField("200");
    	tekstbokser.add(stepsText);
        
    	      
        
       
        getContentPane().add(tekstbokser, BorderLayout.CENTER);
       
    //Lager knapperad med pne og lukke knapp
		JPanel knapperad = new JPanel(new GridLayout(1,2,230,20));
		
		Button avbrytKnapp = new Button("Avbryt");
		Button okKnapp = new Button("Ok");
		    
		knapperad.add(avbrytKnapp);
		knapperad.add(okKnapp);
	
		getContentPane().add(knapperad, BorderLayout.SOUTH);
		
		if (tempLabelNavn != null) setTempLabel(tempLabelNavn);

	
	//Hndterer events (kanpper blir trykt p)
	avbrytKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
		  closeMethod = AVBRYT; 
		  dispose();
		  } 
		});
	
	okKnapp.addActionListener(new ActionListener()
	{
		  public void actionPerformed(ActionEvent e)
		  {
		   if (!QeTextBox.getText().equals("0.0") && !tempFordamperText.getText().equals("0.0"))
		   		{
			   
			   closeMethod = OK;
			   dispose();
		   		}
		   else {JOptionPane.showMessageDialog(null,
				    "Skriv inn gyldige verdier i tekstboksene",
				    "Verdier mangler",
				    JOptionPane.ERROR_MESSAGE);}
		  } 
		});
        
	setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		

        //Set the window's location.
        //setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
	
	//setProperties(current_varmeror);
	pack();
	
	Toolkit toolkit = Toolkit.getDefaultToolkit();  
    Dimension screenSize = toolkit.getScreenSize();
	
	int x = (screenSize.width - getWidth()) / 2;  
	int y = (screenSize.height - getHeight()) / 2;  
	  
	//Set the new frame location  
	setLocation(x, y); 
	this.setVisible(true);
	}
	

public void setProperties(varmeror current_varmeror)
	//Setter verdier i alle tekstbokser fra di verdiene som er i bruk (prosjekt)
	{
	
	
	}
	
public double getFluks()
 	{
		
	 double returnverdi;
	 	try {	
		 	returnverdi = Double.parseDouble(QeTextBox.getText());
	 		}catch (NumberFormatException e) {return 0.0;} 
	 return  returnverdi;
 	}

public double getTemp()
	{
	
 double returnverdi;
 	try {	
	 	returnverdi = Double.parseDouble(tempFordamperText.getText());
 		}catch (NumberFormatException e) {return 0.0;} 
 return  returnverdi;
	}

public int getSteps()
{

int returnverdi;
	try {	
 	returnverdi = Integer.parseInt(stepsText.getText());
		}catch (NumberFormatException e) {return 0;} 
return  returnverdi;
}

public void setTempLabel(String labelNavn)
	{	
	tempFordamper.setText(labelNavn);
	}


}


